/*===========================================================================*/
/*   (Llib/time.scm)                                                         */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue 12 May 2020 08:36:09 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.3h/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.3h/lib/bigloo/4.3h -unsafe -safee -copt -fPIC -copt -IPosix Llib/time.scm -o objs/time.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
} *BgL_schedulerz00_bglt;


static obj_t BGl_z62timezd2ze3secondsz53zz__ft_timez00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__ft_timez00();
static obj_t BGl_methodzd2initzd2zz__ft_timez00();
static obj_t BGl_gczd2rootszd2initz00zz__ft_timez00();
BGL_EXPORTED_DECL obj_t BGl_currentzd2timezd2zz__ft_timez00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_timezf3zf3zz__ft_timez00(obj_t);
extern BgL_schedulerz00_bglt BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__ft_timez00 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_secondszd2ze3timez31zz__ft_timez00(int);
static obj_t BGl_toplevelzd2initzd2zz__ft_timez00();
static obj_t BGl_genericzd2initzd2zz__ft_timez00();
static obj_t BGl_z62currentzd2timezb0zz__ft_timez00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_timezd2ze3secondsz31zz__ft_timez00(int);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_timez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_schedulerz00_bglt);
static obj_t BGl_cnstzd2initzd2zz__ft_timez00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_timez00();
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_timez00();
static obj_t BGl_z62secondszd2ze3timez53zz__ft_timez00(obj_t, obj_t);
static obj_t BGl_z62timezf3z91zz__ft_timez00(obj_t, obj_t);
static obj_t __cnst[ 1 ] ;


DEFINE_STRING( BGl_string1070z00zz__ft_timez00, BgL_bgl_string1070za700za7za7_1079za7, "&time->seconds", 14 );
DEFINE_STRING( BGl_string1071z00zz__ft_timez00, BgL_bgl_string1071za700za7za7_1080za7, "bint", 4 );
DEFINE_STRING( BGl_string1072z00zz__ft_timez00, BgL_bgl_string1072za700za7za7_1081za7, "&seconds->time", 14 );
DEFINE_STRING( BGl_string1073z00zz__ft_timez00, BgL_bgl_string1073za700za7za7_1082za7, "__ft_time", 9 );
DEFINE_STRING( BGl_string1074z00zz__ft_timez00, BgL_bgl_string1074za700za7za7_1083za7, "current-time ", 13 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_secondszd2ze3timezd2envze3zz__ft_timez00, BgL_bgl_za762secondsza7d2za7e31084za7, BGl_z62secondszd2ze3timez53zz__ft_timez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_timezf3zd2envz21zz__ft_timez00, BgL_bgl_za762timeza7f3za791za7za7_1085za7, BGl_z62timezf3z91zz__ft_timez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_timezd2ze3secondszd2envze3zz__ft_timez00, BgL_bgl_za762timeza7d2za7e3sec1086za7, BGl_z62timezd2ze3secondsz53zz__ft_timez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_currentzd2timezd2envz00zz__ft_timez00, BgL_bgl_za762currentza7d2tim1087z00, va_generic_entry, BGl_z62currentzd2timezb0zz__ft_timez00, BUNSPEC, -1 );
DEFINE_STRING( BGl_string1068z00zz__ft_timez00, BgL_bgl_string1068za700za7za7_1088za7, "Llib/time.scm", 13 );
DEFINE_STRING( BGl_string1069z00zz__ft_timez00, BgL_bgl_string1069za700za7za7_1089za7, "/builddir/build/BUILD/bigloo-4.3h/api/fthread/src/Llib/time.scm", 63 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ft_timez00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_timez00(long BgL_checksumz00_43, char * BgL_fromz00_44)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_timez00))
{ 
BGl_requirezd2initializa7ationz75zz__ft_timez00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__ft_timez00(); 
BGl_libraryzd2moduleszd2initz00zz__ft_timez00(); 
BGl_cnstzd2initzd2zz__ft_timez00(); 
BGl_importedzd2moduleszd2initz00zz__ft_timez00(); 
return 
BGl_toplevelzd2initzd2zz__ft_timez00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_timez00()
{
{ /* Llib/time.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_time"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_time"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_time"); 
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__ft_time"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ft_time"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ft_time"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_timez00()
{
{ /* Llib/time.scm 15 */
{ /* Llib/time.scm 15 */
obj_t BgL_cportz00_30;
{ /* Llib/time.scm 15 */
obj_t BgL_stringz00_38;
BgL_stringz00_38 = BGl_string1074z00zz__ft_timez00; 
{ /* Llib/time.scm 15 */
obj_t BgL_startz00_39;
BgL_startz00_39 = 
BINT(((long)0)); 
{ /* Llib/time.scm 15 */
obj_t BgL_endz00_40;
BgL_endz00_40 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_38))); 
{ /* Llib/time.scm 15 */

BgL_cportz00_30 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_38, BgL_startz00_39, BgL_endz00_40); } } } } 
{ 
long BgL_iz00_31;
BgL_iz00_31 = ((long)0); 
BgL_loopz00_32:
if(
(BgL_iz00_31==((long)-1)))
{ /* Llib/time.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/time.scm 15 */
{ /* Llib/time.scm 15 */
obj_t BgL_arg1077z00_34;
{ /* Llib/time.scm 15 */

{ /* Llib/time.scm 15 */
obj_t BgL_locationz00_36;
BgL_locationz00_36 = 
BBOOL(((bool_t)0)); 
{ /* Llib/time.scm 15 */

BgL_arg1077z00_34 = 
BGl_readz00zz__readerz00(BgL_cportz00_30, BgL_locationz00_36); } } } 
{ /* Llib/time.scm 15 */
int BgL_tmpz00_68;
BgL_tmpz00_68 = 
(int)(BgL_iz00_31); 
CNST_TABLE_SET(BgL_tmpz00_68, BgL_arg1077z00_34); } } 
{ /* Llib/time.scm 15 */
int BgL_auxz00_37;
BgL_auxz00_37 = 
(int)(
(BgL_iz00_31-((long)1))); 
{ 
long BgL_iz00_73;
BgL_iz00_73 = 
(long)(BgL_auxz00_37); 
BgL_iz00_31 = BgL_iz00_73; 
goto BgL_loopz00_32;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ft_timez00()
{
{ /* Llib/time.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_timez00()
{
{ /* Llib/time.scm 15 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string1068z00zz__ft_timez00)); 
return BFALSE;} 

}



/* current-time */
BGL_EXPORTED_DEF obj_t BGl_currentzd2timezd2zz__ft_timez00(obj_t BgL_oz00_3)
{
{ /* Llib/time.scm 31 */
return 
BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(
BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(
CNST_TABLE_REF(((long)0)), BgL_oz00_3));} 

}



/* &current-time */
obj_t BGl_z62currentzd2timezb0zz__ft_timez00(obj_t BgL_envz00_18, obj_t BgL_oz00_19)
{
{ /* Llib/time.scm 31 */
return 
BGl_currentzd2timezd2zz__ft_timez00(BgL_oz00_19);} 

}



/* time? */
BGL_EXPORTED_DEF bool_t BGl_timezf3zf3zz__ft_timez00(obj_t BgL_objz00_4)
{
{ /* Llib/time.scm 37 */
return 
INTEGERP(BgL_objz00_4);} 

}



/* &time? */
obj_t BGl_z62timezf3z91zz__ft_timez00(obj_t BgL_envz00_20, obj_t BgL_objz00_21)
{
{ /* Llib/time.scm 37 */
return 
BBOOL(
BGl_timezf3zf3zz__ft_timez00(BgL_objz00_21));} 

}



/* time->seconds */
BGL_EXPORTED_DEF obj_t BGl_timezd2ze3secondsz31zz__ft_timez00(int BgL_xz00_5)
{
{ /* Llib/time.scm 43 */
return 
BINT(BgL_xz00_5);} 

}



/* &time->seconds */
obj_t BGl_z62timezd2ze3secondsz53zz__ft_timez00(obj_t BgL_envz00_22, obj_t BgL_xz00_23)
{
{ /* Llib/time.scm 43 */
{ /* Llib/time.scm 43 */
int BgL_auxz00_86;
{ /* Llib/time.scm 43 */
obj_t BgL_tmpz00_87;
if(
INTEGERP(BgL_xz00_23))
{ /* Llib/time.scm 43 */
BgL_tmpz00_87 = BgL_xz00_23
; }  else 
{ 
obj_t BgL_auxz00_90;
BgL_auxz00_90 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1069z00zz__ft_timez00, 
BINT(((long)1973)), BGl_string1070z00zz__ft_timez00, BGl_string1071z00zz__ft_timez00, BgL_xz00_23); 
FAILURE(BgL_auxz00_90,BFALSE,BFALSE);} 
BgL_auxz00_86 = 
CINT(BgL_tmpz00_87); } 
return 
BGl_timezd2ze3secondsz31zz__ft_timez00(BgL_auxz00_86);} } 

}



/* seconds->time */
BGL_EXPORTED_DEF obj_t BGl_secondszd2ze3timez31zz__ft_timez00(int BgL_xz00_6)
{
{ /* Llib/time.scm 49 */
return 
BINT(BgL_xz00_6);} 

}



/* &seconds->time */
obj_t BGl_z62secondszd2ze3timez53zz__ft_timez00(obj_t BgL_envz00_24, obj_t BgL_xz00_25)
{
{ /* Llib/time.scm 49 */
{ /* Llib/time.scm 49 */
int BgL_auxz00_97;
{ /* Llib/time.scm 49 */
obj_t BgL_tmpz00_98;
if(
INTEGERP(BgL_xz00_25))
{ /* Llib/time.scm 49 */
BgL_tmpz00_98 = BgL_xz00_25
; }  else 
{ 
obj_t BgL_auxz00_101;
BgL_auxz00_101 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1069z00zz__ft_timez00, 
BINT(((long)2228)), BGl_string1072z00zz__ft_timez00, BGl_string1071z00zz__ft_timez00, BgL_xz00_25); 
FAILURE(BgL_auxz00_101,BFALSE,BFALSE);} 
BgL_auxz00_97 = 
CINT(BgL_tmpz00_98); } 
return 
BGl_secondszd2ze3timez31zz__ft_timez00(BgL_auxz00_97);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ft_timez00()
{
{ /* Llib/time.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ft_timez00()
{
{ /* Llib/time.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_timez00()
{
{ /* Llib/time.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_timez00()
{
{ /* Llib/time.scm 15 */
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)414892275), 
BSTRING_TO_STRING(BGl_string1073z00zz__ft_timez00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)0), 
BSTRING_TO_STRING(BGl_string1073z00zz__ft_timez00)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(((long)398966270), 
BSTRING_TO_STRING(BGl_string1073z00zz__ft_timez00));} 

}

#ifdef __cplusplus
}
#endif
